package ZipTeamOrange.model;

import ZipTeamOrange.model.Audit.UserDateAudit;
import ZipTeamOrange.model.Message;
import ZipTeamOrange.model.User;
import javax.persistence.*;
import javax.validation.constraints.NotBlank;
import java.util.Set;

@Entity
@Table(name = "chats")
public class Chat extends UserDateAudit {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotBlank
    private String topic;

    @OneToMany(mappedBy = "chat",
    cascade = CascadeType.ALL,
    fetch = FetchType.EAGER,
    orphanRemoval = true)
    private Set<Message> messages;

//    @ManyToMany(mappedBy = "chat")
//    private Set<User> users;

    public Chat(String topic, Set<Message> messages) {
        this.topic = topic;
        this.messages = messages;
    }

    public Chat() { }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTopic() {
        return topic;
    }

    public void setTopic(String topic) {
        this.topic = topic;
    }

    public Set<Message> getMessages() {
        return messages;
    }

    public void setMessages(Set<Message> messages) {
        this.messages = messages;
    }

    //    public Set<User> getUsers() {
//        return users;
//    }
//
//    public void setUsers(Set<User> users) {
//        this.users = users;
//    }
}
