package ZipTeamOrange.repository;

import ZipTeamOrange.model.Chat;
import ZipTeamOrange.model.Message;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;
import java.util.Optional;

public interface MessageRepository extends JpaRepository<Message, Long> {

    Optional<Message> findById(Long messageId);

    Page<Message> findByCreatedBy(Long userId, Pageable pageable);

    long countByCreatedBy(Long userId);

//    @Query("SELECT COUNT(m.id) from Message v where v.user.id = :userId")
//    long countByUserId(@Param("userId") Long userId);

    List<Message> findByIdIn(List<Long> messageIds);

    List<Message> findByIdIn(List<Long> messageIds, Sort sort);

}
